import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class main {
    public static void main(String[] args){

        // 23, x, +, (,0, 5, x,), ^, 2, -, 1
        String ausdruck = "23x +(0,5x)^20−10";

        ArrayList<String> separatedChar = new ArrayList<String>();

        List<Token> tokenList = new ArrayList<>();

        separatedChar.add("|");
        for (char c : ausdruck.toCharArray()) {

            if(Character.isWhitespace(c)){
                continue;
            }

            if(Character.isDigit(c)) {

                separatedChar.add( String.valueOf(c) );

            } else {
                separatedChar.add("|");
                separatedChar.add( String.valueOf(c) );
                separatedChar.add("|");
            }
        }
        separatedChar.add("|");

        System.out.println(separatedChar);

        ArrayList<String> tokens = new ArrayList<String>();
        String temp = "";


        for(String c : separatedChar) {

            if(Objects.equals(c, "|")) {

                if(temp != "") {
                    tokens.add(temp);
                }
                temp = "";
            } else {
                temp = temp + c;
            }
        }

        System.out.println(tokens);

        Boolean notANumber = false;

        for(String s : tokens) {

            try {
                int val = Integer.parseInt(s);
                tokenList.add(new Token(TokenType.number, s));
            } catch (NumberFormatException ignored) {

                notANumber = true;

            }

            if(notANumber) {

                if (Character.isLetter( s.charAt(0) )) {
                    tokenList.add(new Token(TokenType.var, s));
                } else {
                    tokenList.add(new Token(TokenType.special, s));
                }
                notANumber = false;
            }

        }

        for(Token t : tokenList) {
            System.out.println(t.getTokenString() + " " + t.getTokenType());
        }



        /*

        for(int i = 0; i < ausdruck.length(); i++) {

            if(Character.isWhitespace(ausdruck.charAt(i))) {
                continue;
            }


            if(typeOfLast == TokenType.number && Character.isDigit(ausdruck.charAt(i)) && i != 0) {

                temp = temp + ausdruck.charAt(i-1);
                //charList.add(String.valueOf( ausdruck.charAt(i) ));

            } else {

                if(temp.equals("")) {

                    charList.add(String.valueOf( "|" + ausdruck.charAt(i) + "|"));

                } else {

                    charList.add(String.valueOf( "|" + temp +  "|"));
                    charList.add(String.valueOf( "|" + ausdruck.charAt(i) + "|"));

                    temp = "";
                }
            }


            if(Character.isDigit(ausdruck.charAt(i)))
                typeOfLast = TokenType.number;
            else if(Character.isLetter(ausdruck.charAt(i)))
                typeOfLast = TokenType.var;
            else
                typeOfLast = TokenType.special;

        }

        System.out.println(charList);


        /*
        for (char c : ausdruck.toCharArray()) {

            if(Character.isWhitespace(c)) {
                continue;
            }


            if(typeOfLast == TokenType.number && Character.isDigit(c)) {
                System.out.print(c);
            } else {
                System.out.println();
                System.out.print(c);
            }

            if(Character.isDigit(c))
                typeOfLast = TokenType.number;
            else if(Character.isLetter(c))
                typeOfLast = TokenType.var;
            else
                typeOfLast = TokenType.special;
        }
        */

    }
}

